//------------------------------------------------------------------------------
//
//  npch.h
//
// ANTZ - 3D data viewer with realtime real-world interaction based on NPE.
//
// ANTZ is hosted at http://temporalzone.com and NPE at http://neuralphysics.org
//
// Written in 2010-2012 by Shane Saxon - contact@saxondigital.net
//
// Please see main.c for a complete list of additional code contributors
//
// To the extent possible under law, the author(s) have dedicated all copyright 
// and related and neighboring rights to this software to the public domain
// worldwide. This software is distributed without any warranty.
//
// Released under the CC0 license, which is GPL compatible.
//
// You should have received a copy of the CC0 Public Domain Dedication along
// with this software (license file named COPYING.txt). If not, see
// http://creativecommons.org/publicdomain/zero/1.0/
//
//------------------------------------------------------------------------------

#ifndef NPCH_H_
#define NPCH_H_

#include "../npdata.h"

//JJ

//------------------------------------------------------------------------------
void npInitCh (void* dataRef);
void npCloseCh (void* dataRef);

void npChFileOpen (const char* filePath, void* dataRef);

void npChMapImport (char* buffer, int size, void* dataRef);
void npChDataImport (char* buffer, int size, void* dataRef);

void npChMapExport (char* buffer, int *size, void* dataRef);
void npChDataExport (char* buffer, int *size, void* dataRef);

void npChMapAttributeAdd (int channel, int attribute, int track, void* dataRef);
void npChMapAttributeDelete (int channel, int attribute, void* dataRef);

void npNewChannel (int channel, void* dataRef);
void npDeleteChannel (int channel, void* dataRef);

void npChSubscribeNode (NPnodePtr node, void* dataRef);
void npChRemoveNode (NPnodePtr node, void* dataRef);

void npUpdateCh (void* dataRef);

//--- will add stream functions such as local IO and UDP
void npChOpenInputStream (int needToFigureOut, void* dataRef);
void npChCloseInputStream (int needToFigureOut, void* dataRef);
void npChOpenOutputStream (int needToFigureOut, void* dataRef);
void npChCloseOutStream (int needToFigureOut, void* dataRef);


//JJ-end

#endif

